# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from . import time as _time

__all__ = ['CertificateArgs', 'Certificate']

@pulumi.input_type
class CertificateArgs:
    def __init__(__self__, *,
                 app: pulumi.Input[str],
                 hostname: pulumi.Input[str]):
        """
        The set of arguments for constructing a Certificate resource.
        """
        pulumi.set(__self__, "app", app)
        pulumi.set(__self__, "hostname", hostname)

    @property
    @pulumi.getter
    def app(self) -> pulumi.Input[str]:
        return pulumi.get(self, "app")

    @app.setter
    def app(self, value: pulumi.Input[str]):
        pulumi.set(self, "app", value)

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Input[str]:
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: pulumi.Input[str]):
        pulumi.set(self, "hostname", value)


class Certificate(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a Certificate resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CertificateArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a Certificate resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param CertificateArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CertificateArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CertificateArgs.__new__(CertificateArgs)

            if app is None and not opts.urn:
                raise TypeError("Missing required property 'app'")
            __props__.__dict__["app"] = app
            if hostname is None and not opts.urn:
                raise TypeError("Missing required property 'hostname'")
            __props__.__dict__["hostname"] = hostname
            __props__.__dict__["acme_alpn_configured"] = None
            __props__.__dict__["acme_dns_configured"] = None
            __props__.__dict__["certificate_authority"] = None
            __props__.__dict__["checks"] = None
            __props__.__dict__["client_status"] = None
            __props__.__dict__["configured"] = None
            __props__.__dict__["created_at"] = None
            __props__.__dict__["dns_provider"] = None
            __props__.__dict__["dns_validation_hostname"] = None
            __props__.__dict__["dns_validation_instructions"] = None
            __props__.__dict__["dns_validation_target"] = None
            __props__.__dict__["fly_id"] = None
            __props__.__dict__["input"] = None
            __props__.__dict__["is_apex"] = None
            __props__.__dict__["is_wildcard"] = None
            __props__.__dict__["source"] = None
        super(Certificate, __self__).__init__(
            'flyio:index:Certificate',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Certificate':
        """
        Get an existing Certificate resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = CertificateArgs.__new__(CertificateArgs)

        __props__.__dict__["acme_alpn_configured"] = None
        __props__.__dict__["acme_dns_configured"] = None
        __props__.__dict__["app"] = None
        __props__.__dict__["certificate_authority"] = None
        __props__.__dict__["checks"] = None
        __props__.__dict__["client_status"] = None
        __props__.__dict__["configured"] = None
        __props__.__dict__["created_at"] = None
        __props__.__dict__["dns_provider"] = None
        __props__.__dict__["dns_validation_hostname"] = None
        __props__.__dict__["dns_validation_instructions"] = None
        __props__.__dict__["dns_validation_target"] = None
        __props__.__dict__["fly_id"] = None
        __props__.__dict__["hostname"] = None
        __props__.__dict__["input"] = None
        __props__.__dict__["is_apex"] = None
        __props__.__dict__["is_wildcard"] = None
        __props__.__dict__["source"] = None
        return Certificate(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="acmeAlpnConfigured")
    def acme_alpn_configured(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "acme_alpn_configured")

    @property
    @pulumi.getter(name="acmeDnsConfigured")
    def acme_dns_configured(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "acme_dns_configured")

    @property
    @pulumi.getter
    def app(self) -> pulumi.Output[str]:
        return pulumi.get(self, "app")

    @property
    @pulumi.getter(name="certificateAuthority")
    def certificate_authority(self) -> pulumi.Output[str]:
        return pulumi.get(self, "certificate_authority")

    @property
    @pulumi.getter
    def checks(self) -> pulumi.Output['outputs.CertificateStateChecks']:
        return pulumi.get(self, "checks")

    @property
    @pulumi.getter(name="clientStatus")
    def client_status(self) -> pulumi.Output[str]:
        return pulumi.get(self, "client_status")

    @property
    @pulumi.getter
    def configured(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "configured")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output['_time.outputs.Time']:
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="dnsProvider")
    def dns_provider(self) -> pulumi.Output[str]:
        return pulumi.get(self, "dns_provider")

    @property
    @pulumi.getter(name="dnsValidationHostname")
    def dns_validation_hostname(self) -> pulumi.Output[str]:
        return pulumi.get(self, "dns_validation_hostname")

    @property
    @pulumi.getter(name="dnsValidationInstructions")
    def dns_validation_instructions(self) -> pulumi.Output[str]:
        return pulumi.get(self, "dns_validation_instructions")

    @property
    @pulumi.getter(name="dnsValidationTarget")
    def dns_validation_target(self) -> pulumi.Output[str]:
        return pulumi.get(self, "dns_validation_target")

    @property
    @pulumi.getter(name="flyId")
    def fly_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "fly_id")

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Output[str]:
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter
    def input(self) -> pulumi.Output['outputs.CertificateArgs']:
        return pulumi.get(self, "input")

    @property
    @pulumi.getter(name="isApex")
    def is_apex(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "is_apex")

    @property
    @pulumi.getter(name="isWildcard")
    def is_wildcard(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "is_wildcard")

    @property
    @pulumi.getter
    def source(self) -> pulumi.Output[str]:
        return pulumi.get(self, "source")

